/* Automatically generated from Squeak on #(21 August 2002 9:57:39 am) */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

/* Default EXPORT macro that does nothing (see comment in sq.h): */
#define EXPORT(returnType) returnType

/* Do not include the entire sq.h file but just those parts needed. */
/*  The virtual machine proxy definition */
#include "sqVirtualMachine.h"
/* Configuration options */
#include "sqConfig.h"
/* Platform specific definitions */
#include "sqPlatformSpecific.h"

#define true 1
#define false 0
#define null 0  /* using 'null' because nil is predefined in Think C */
#ifdef SQUEAK_BUILTIN_PLUGIN
#undef EXPORT
// was #undef EXPORT(returnType) but screws NorCroft cc
#define EXPORT(returnType) static returnType
#endif
#include "PseudoTTYPlugin.h"

/* memory access macros */
#define byteAt(i) (*((unsigned char *) (i)))
#define byteAtput(i, val) (*((unsigned char *) (i)) = val)
#define longAt(i) (*((int *) (i)))
#define longAtput(i, val) (*((int *) (i)) = val)


/*** Variables ***/

#ifdef SQUEAK_BUILTIN_PLUGIN
extern
#endif
struct VirtualMachine* interpreterProxy;
static const char *moduleName =
#ifdef SQUEAK_BUILTIN_PLUGIN
	"PseudoTTYPlugin 21 August 2002 (i)"
#else
	"PseudoTTYPlugin 21 August 2002 (e)"
#endif
;
static int sCOAFfn;

/*** Function Prototypes ***/
static AsyncFile * asyncFileValueOf(int oop);
#pragma export on
EXPORT(const char*) getModuleName(void);
#pragma export off
static int halt(void);
#pragma export on
EXPORT(int) initialiseModule(void);
#pragma export off
static int msg(char *s);
#pragma export on
EXPORT(int) primPtyClose(void);
EXPORT(int) primPtyForkAndExec(void);
EXPORT(int) primPtyWindowSize(void);
EXPORT(int) setInterpreter(struct VirtualMachine* anInterpreter);
EXPORT(int) shutdownModule(void);
#pragma export off


/*	Return a pointer to the first byte of the async file record within the given Smalltalk bytes object, or nil if oop is not an async file record. */

static AsyncFile * asyncFileValueOf(int oop) {
	interpreterProxy->success((!((oop & 1))) && ((interpreterProxy->isBytes(oop)) && ((interpreterProxy->slotSizeOf(oop)) == (sizeof(AsyncFile)))));
	if (interpreterProxy->failed()) {
		return null;
	}
	return (AsyncFile *) (oop + 4);
}


/*	Note: This is hardcoded so it can be run from Squeak.
	The module name is used for validating a module *after*
	it is loaded to check if it does really contain the module
	we're thinking it contains. This is important! */

EXPORT(const char*) getModuleName(void) {
	return moduleName;
}

static int halt(void) {
	;
}

EXPORT(int) initialiseModule(void) {
	interpreterProxy->ioLoadFunctionFrom("initializeModule", "AsynchFilePlugin");
	return ptyInit();
}

static int msg(char *s) {
	fprintf(stderr, "\n%s: %s", moduleName, s);
}

EXPORT(int) primPtyClose(void) {
	AsyncFile *f;
	int fHandle;

	fHandle = interpreterProxy->stackValue(0);
	if (interpreterProxy->failed()) {
		return null;
	}
	f = asyncFileValueOf(fHandle);
	if (!(interpreterProxy->failed())) {
		ptyClose(f);
	}
	if (interpreterProxy->failed()) {
		return null;
	}
	interpreterProxy->pop(1);
	return null;
}

EXPORT(int) primPtyForkAndExec(void) {
	int cmdLen;
	AsyncFile *f;
	int argIdx;
	int argLen;
	int fOop;
	int cmdIdx;
	int cmd;
	int args;
	int semaIndex;

	cmd = interpreterProxy->stackValue(2);
	args = interpreterProxy->stackValue(1);
	semaIndex = interpreterProxy->stackIntegerValue(0);
	if (interpreterProxy->failed()) {
		return null;
	}
	interpreterProxy->success(interpreterProxy->isBytes(cmd));
	interpreterProxy->success(interpreterProxy->isPointers(args));
	if (interpreterProxy->failed()) {
		return null;
	}
	cmdIdx = ((int) (interpreterProxy->firstIndexableField(cmd)));

	/* in bytes */

	cmdLen = interpreterProxy->slotSizeOf(cmd);
	argIdx = ((int) (interpreterProxy->firstIndexableField(args)));

	/* in fields */

	argLen = interpreterProxy->slotSizeOf(args);
	fOop = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classByteArray(), sizeof(AsyncFile));
	f = asyncFileValueOf(fOop);
	if (!(interpreterProxy->failed())) {
		ptyForkAndExec(f, semaIndex, cmdIdx, cmdLen, argIdx, argLen);
	}
	if (interpreterProxy->failed()) {
		return null;
	}
	interpreterProxy->popthenPush(4, fOop);
	return null;
}

EXPORT(int) primPtyWindowSize(void) {
	AsyncFile *f;
	int fHandle;
	int cols;
	int rows;

	fHandle = interpreterProxy->stackValue(2);
	cols = interpreterProxy->stackIntegerValue(1);
	rows = interpreterProxy->stackIntegerValue(0);
	if (interpreterProxy->failed()) {
		return null;
	}
	f = asyncFileValueOf(fHandle);
	if (!(interpreterProxy->failed())) {
		ptyWindowSize(f, cols, rows);
	}
	if (interpreterProxy->failed()) {
		return null;
	}
	interpreterProxy->pop(3);
	return null;
}


/*	Note: This is coded so that is can be run from Squeak. */

EXPORT(int) setInterpreter(struct VirtualMachine* anInterpreter) {
	int ok;

	interpreterProxy = anInterpreter;
	ok = interpreterProxy->majorVersion() == VM_PROXY_MAJOR;
	if (ok == 0) {
		return 0;
	}
	ok = interpreterProxy->minorVersion() >= VM_PROXY_MINOR;
	return ok;
}

EXPORT(int) shutdownModule(void) {
	return ptyShutdown();
}


#ifdef SQUEAK_BUILTIN_PLUGIN


void* PseudoTTYPlugin_exports[][3] = {
	{"PseudoTTYPlugin", "primPtyClose", (void*)primPtyClose},
	{"PseudoTTYPlugin", "primPtyWindowSize", (void*)primPtyWindowSize},
	{"PseudoTTYPlugin", "shutdownModule", (void*)shutdownModule},
	{"PseudoTTYPlugin", "primPtyForkAndExec", (void*)primPtyForkAndExec},
	{"PseudoTTYPlugin", "getModuleName", (void*)getModuleName},
	{"PseudoTTYPlugin", "initialiseModule", (void*)initialiseModule},
	{"PseudoTTYPlugin", "setInterpreter", (void*)setInterpreter},
	{NULL, NULL, NULL}
};


#endif /* ifdef SQ_BUILTIN_PLUGIN */

